//
//  Protocols.h
//  UCPFramework
//
//  Created by Christian Weykopf on 28.09.09.
//  Copyright 2009 STARFACE GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

@class XMPPConnection;
@class UCPServerService;

@protocol SFServerProtocol <NSObject>

- (id) initWithDelegate: (id)delegate xmppConnection: (XMPPConnection *)xmppConnection;
- (NSString *) providedService;

@end

@protocol SFClientProtocol <NSObject>

- (id) initWithDelegate: (id)delegate;
- (NSString *) providedService;
- (BOOL) registerInvocation: (NSInvocation *) invocation forServiceName: (NSString *)serviceName;
- (void) removeInvocationForTarget: (id)aTarget serviceName: (NSString *)aServiceName;

@end

/*!
    @category NSObject(UCPServerService)
    @brief Informal protocol for the delegate.
 */
@interface NSObject (UCPServerService)

- (void) ucpServerService: (UCPServerService *)service responseTimedOut: (UInt32)callType;
- (void) ucpServerService: (UCPServerService *)service receivedError: (NSError *)error;

@end
