//
//  UCPServerCallProtocol.h
//  UCPFramework
//
//  Created by Christian Weykopf on 20.10.09.
//  Copyright 2009 STARFACE GmbH. All rights reserved.
//

/*!
 Keys for Values in callState
 */
extern NSString * const SFCallStateIdKey;
extern NSString * const SFCallStateStateKey;
extern NSString * const SFCallStateTimestampKey;
extern NSString * const SFCallStateCallerNumberKey;
extern NSString * const SFCallStateCallerNameKey;
extern NSString * const SFCallStateCalledNumberKey;
extern NSString * const SFCallStateCalledNameKey;

@interface NSObject (UCPServerCallRequest)

- (BOOL) getPhoneIdsWithDelegate: (id)delegate;
- (BOOL) getCallIdsWithDelegate: (id)delegate;
- (BOOL) getCallState: (NSString *)callId delegate: (id)delegate;
- (BOOL) placeCallWithPhone: (NSString *)phoneNumber phoneID: (NSString *)phoneId callId: (NSString *)callId delegate: (id)delegate;
- (BOOL) placeCallWithNumber: (NSString *)phoneNumber originatingNumber: (NSString *)originatingNumber callId: (NSString *)callId delegate: (id)delegate;
- (BOOL) hangupCall: (NSString *)callId delegate: (id)delegate;

@end

@interface NSObject (UCPServerCallResponse)

- (void) ucpServerCall: (id)serverCall receivedPhoneIds: (NSArray *)phoneIds;
- (void) ucpServerCall: (id)serverCall receivedCallIds: (NSArray *)callIds;
- (void) ucpServerCall: (id)serverCall receivedCallState: (NSDictionary *)callState;
- (void) ucpServerCall: (id)serverCall receivedPlaceCall: (NSString *)callId;
- (void) ucpServerCall: (id)serverCall receivedHangupCall: (NSNumber *)result;

@end

/*!
 @category NSObject(UCPClientCall)
 @brief Informal protocol for the delegate.
 */
@interface NSObject (UCPClientCall)

/*!
 @brief Method to implement by the delegeate.
 @param callState Dictionary with the callstate. 
 */
- (void) receivedCallState: (NSDictionary *)callState;

@end
