//
//  UCPServerFaxProtocol.h
//  UCPFramework
//
//  Created by Christian Weykopf on 20.10.09.
//  Copyright 2009 STARFACE GmbH. All rights reserved.
//

/*!
 Keys for Values in faxState
 */
extern NSString * const SFFaxStateIdKey;
extern NSString * const SFFaxStateStateKey;
extern NSString * const SFFaxStateTimestampKey;

extern NSString * const SFDigestTypeMD5;
extern NSString * const SFDigestTypeSHA;

@interface NSObject (UCPServerFaxRequest)

- (BOOL) getFaxState: (NSString *)faxId delegate: (id)delegate;
- (BOOL) sendFax: (NSString *)faxNumber faxId: (NSString *)faxId textFile: (NSString *)textFile pdfFile: (NSString *)pdfFile delegate: (id)delegate;

@end

@interface NSObject (UCPServerFaxResponse)

- (void) ucpServerFax: (id)serverFax receivedFaxState: (NSDictionary *)faxState;
- (void) ucpServerFax: (id)serverFax receivedSendFax: (NSString *)faxId;

@end

/*!
 @category NSObject(UCPClientFax)
 @brief Informal protocol for the delegate.
 */

@interface NSObject (UCPClientFax)

/*!
 @brief Method to implement by the delegeate.
 @param faxState Dictionary with the faxstate. 
 */
- (void) receivedFaxState: (NSDictionary *)faxState;

@end

