//
//  UCPCommunicationRedirectProtocol.h
//  UCPFramework
//
//  Created by Christian Weykopf on 28.01.10.
//  Copyright 2010 STARFACE GmbH. All rights reserved.
//


// keys for Redirect Setting
extern NSString * const SFRedirectSettingTypeKey;
extern NSString * const SFRedirectSettingCalledNumberKey;
extern NSString * const SFRedirectSettingIsGroupCallKey;
extern NSString * const SFRedirectSettingIsEnabledKey;
extern NSString * const SFRedirectSettingDestinationTypeKey;
extern NSString * const SFRedirectSettingDestinationKey;
extern NSString * const SFRedirectSettingMailboxesKey;
extern NSString * const SFRedirectSettingTimeoutKey;

// order direction
extern NSString * const SFRedirectSettingOrderAscending;
extern NSString * const SFRedirectSettingOrderDescending;

// redirect setting types
extern NSString * const SFRedirectSettingTypeAlways;
extern NSString * const SFRedirectSettingTypeBusy;
extern NSString * const SFRedirectSettingTypeTimeout;

// Redirect Setting DestinationType
extern NSString * const SFRedirectSettingDestinationTypeVoicemail;
extern NSString * const SFRedirectSettingDestinationTypePhonenumber;

@interface NSObject (UCPServerRedirectRequest)

/*
 typeRestriction string only retrieve settings with the given type
 orderProperty string specify settings property to order results by orderDirection
 */
- (BOOL)getRedirectSettings: (NSString *)typeRestriction orderProperty: (NSString *)orderProperty orderDirection: (NSString *)orderDirection delegte: (id)delegate;

/*
 redirectSettings   list of Redirect Setting    a list of changed redirect settings
 */
- (BOOL)setRedirectSettings: (NSArray *)redirectSettings delegte: (id)delegate;
- (BOOL)setRedirectSettingsWithPlist: (NSData *)redirectSettings delegte: (id)delegate;

/*
 redirectSetting    Redirect Setting    a changed redirect setting
 */
- (BOOL)setRedirectSetting: (NSDictionary *)redirectSetting delegte: (id)delegate;
- (BOOL)setRedirectSettingWithPlist: (NSData *)redirectSetting delegte: (id)delegate;

@end

@interface NSObject (UCPServerRedirectResponse)

- (void) ucpServerRedirect: (id)serverRedirect receivedGetRedirectSettings: (NSArray *)redirectSettings fault: (NSDictionary *)fault;
- (void) ucpServerRedirect: (id)serverRedirect receivedSetRedirectSettings: (NSNumber *)result fault: (NSDictionary *)fault;
- (void) ucpServerRedirect: (id)serverRedirect receivedSetRedirectSetting: (NSNumber *)result fault: (NSDictionary *)fault;

@end
