//
//  UCPFileTransferAgentProtocol.h
//  UCPFramework
//
//  Created by Christian Weykopf on 17.10.09.
//  Copyright 2009 STARFACE GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

// informal protocol to call file transfer methods
@interface NSObject (UCPFileTransferAgentResponseRequest)

- (BOOL) initializeTransfer: (NSString *)description
                   fileName: (NSString *)fileName
                   mimeType: (NSString *)mimeType
                   fileSize: (NSString *)fileSize
                 digestName: (NSString *)digestName
                   delegate: (id)delegate;
- (BOOL) sendBlock: (NSString *)slotId
       blockNumber: (NSNumber *)blockNumber
             block: (NSData *)block
       blockDigest: (NSData *)blockDigest
          delegate: (id)delegate;
- (BOOL) finishTransfer: (NSString *)slotId
             fileDigest: (NSData *)fileDigest
               delegate: (id)delegate;

@end

// method called from the agent.
// should be implemented by the delegate
@interface NSObject (UCPFileTransferAgentResponse)

- (void) ucpFileTransferAgent: (id)transferAgent receivedInitializeTransfer: (NSString *)slotId;
- (void) ucpFileTransferAgent: (id)transferAgent receivedSendBlock: (id)result;
- (void) ucpFileTransferAgent: (id)transferAgent receivedFinishTransfer: (id)result;

@end

