//
//  UCPConnection.h
//  UCPFramework
//
//  Created by Christian Weykopf on 17.09.09.
//  Copyright 2009 STARFACE GmbH. All rights reserved.
//


#import "UCPServerService.h"
#import "UCPConnectionProtocol.h"

@interface UCPServerConnection : UCPServerService
{
    NSString *_xmppHost;
    NSUInteger _xmppPort;
    NSString *_userName;
    NSString *_password;
    BOOL _secure;
    BOOL _autoReconnect;
    BOOL _shouldReconnect;
    UCPServerConnectionState _connectionState;
    NSTimer *_probeTimer;
    id _loginDelegate;
}

@property (copy) NSString *xmppHost;
@property (assign) NSUInteger xmppPort;
@property (copy) NSString *userName;
@property (copy) NSString *password;
@property (assign) BOOL secure;
@property (assign) BOOL autoReconnect;
@property (assign) BOOL shouldReconnect;
@property (assign) UCPServerConnectionState connectionState;
@property (retain) NSTimer *probeTimer;
@property (assign) id loginDelegate;

- (id) initWithDelegate:(id)delegate xmppConnection:(XMPPConnection *)xmppConnection;

- (BOOL) loginOnHost: (NSString *)xmppHost 
                port: (NSUInteger)xmppPort 
              secure: (BOOL)secure 
       autoReconnect: (BOOL)autoReconnect 
            username: (NSString *)userName 
            password: (NSString *)password
            delegate: (id)delegate;
- (BOOL) logoutWithDelegate: (id) delegate;
- (BOOL) probeWithDelegate: (id)delegate;
- (BOOL) setProvidedServices: (NSArray *)providedServices delegate: (id)delegate;

- (void) xmppConnection: (XMPPConnection *)sender didReceiveEvent: (enum ConnectionEvent) connectionEvent params: (NSDictionary *)params;

@end
