//
//  XMLRPCError.h
//  XMLRPC
//
//  Created by Christian Weykopf on 21.10.09.
//  Copyright 2009 STARFACE GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

// A Jabber Error Response
/*
 <iq type="error" id="79B54F72-2" from="starface.xmpp.uci@pbx7.starface.de/STARFACE" to="0067@pbx7.starface.de/MacClient">
 <query xmlns="jabber:iq:rpc">
 <methodCall>
 <methodName>
 ucp.v20.server.connection.logout</methodName>
 <params/>
 </methodCall>
 </query>
 <error code="503" type="cancel">
 <service-unavailable xmlns="urn:ietf:params:xml:ns:xmpp-stanzas"/>
 </error>
 </iq>
 */
@interface XMLRPCJabberError : NSObject
{
    NSString *_body;
    NSString *_errorType;
    NSString *_errorCode;
    NSString *_errorCondition;
    NSString *_methodName;
}

@property (copy) NSString *body;
@property (copy) NSString *errorType;
@property (copy) NSString *errorCode;
@property (copy) NSString *errorCondition;
@property (copy) NSString *methodName;

+ (XMLRPCJabberError *) jabberErrorWithXmlRpcString: (NSString *)xmlRpcString;
+ (XMLRPCJabberError *) jabberErrorWithXmlRpcData: (NSData *)data;

- (id)initWithXmlRpcData: (NSData *)data;
- (id)initWithXmlRpcString: (NSString *)xmlRpcString;

@end
